summaryrefslogtreecommitdiff
path: root/plugins/dotenv
diff options
context:
space:
mode:
authorTuowen Zhao <ztuowen@gmail.com>2020-04-24 20:54:33 -0600
committerTuowen Zhao <ztuowen@gmail.com>2020-04-24 20:54:33 -0600
commitc197ad40f1dca62fd1e0e555e7bfc84e39f31223 (patch)
tree5c1e753e0ff2cb9d0e08a699f17352225b9ef9f1 /plugins/dotenv
parent0b67340fd2fe9330d8487491e1983ad1a111fb2b (diff)
parent2560f04982dfc2693221c7c0f47d1a71df09a794 (diff)
downloadzsh-c197ad40f1dca62fd1e0e555e7bfc84e39f31223.tar.gz
zsh-c197ad40f1dca62fd1e0e555e7bfc84e39f31223.tar.bz2
zsh-c197ad40f1dca62fd1e0e555e7bfc84e39f31223.zip
Merge branch 'master' of https://github.com/ohmyzsh/ohmyzsh
Diffstat (limited to 'plugins/dotenv')
-rw-r--r--plugins/dotenv/README.md34
-rw-r--r--plugins/dotenv/dotenv.plugin.zsh51
2 files changed, 60 insertions, 25 deletions
diff --git a/plugins/dotenv/README.md b/plugins/dotenv/README.md
index dbc02bf61..f66124731 100644
--- a/plugins/dotenv/README.md
+++ b/plugins/dotenv/README.md
@@ -4,9 +4,7 @@ Automatically load your project ENV variables from `.env` file when you `cd` int
Storing configuration in the environment is one of the tenets of a [twelve-factor app](https://www.12factor.net). Anything that is likely to change between deployment environments, such as resource handles for databases or credentials for external services, should be extracted from the code into environment variables.
-## Installation
-
-Just add the plugin to your `.zshrc`:
+To use it, add `dotenv` to the plugins array in your zshrc file:
```sh
plugins=(... dotenv)
@@ -17,22 +15,26 @@ plugins=(... dotenv)
Create `.env` file inside your project root directory and put your ENV variables there.
For example:
+
```sh
export AWS_S3_TOKEN=d84a83539134f28f412c652b09f9f98eff96c9a
export SECRET_KEY=7c6c72d959416d5aa368a409362ec6e2ac90d7f
export MONGO_URI=mongodb://127.0.0.1:27017
export PORT=3001
```
+
`export` is optional. This format works as well:
+
```sh
AWS_S3_TOKEN=d84a83539134f28f412c652b09f9f98eff96c9a
SECRET_KEY=7c6c72d959416d5aa368a409362ec6e2ac90d7f
MONGO_URI=mongodb://127.0.0.1:27017
PORT=3001
```
+
You can even mix both formats, although it's probably a bad idea.
-## Plugin options
+## Settings
### ZSH_DOTENV_FILE
@@ -40,7 +42,7 @@ You can also modify the name of the file to be loaded with the variable `ZSH_DOT
If the variable isn't set, the plugin will default to use `.env`.
For example, this will make the plugin look for files named `.dotenv` and load them:
-```
+```zsh
# in ~/.zshrc, before Oh My Zsh is sourced:
ZSH_DOTENV_FILE=.dotenv
```
@@ -48,6 +50,27 @@ ZSH_DOTENV_FILE=.dotenv
### ZSH_DOTENV_PROMPT
Set `ZSH_DOTENV_PROMPT=false` in your zshrc file if you don't want the confirmation message.
+You can also choose the `Always` option when prompted to always allow sourcing the .env file
+in that directory. See the next section for more details.
+
+### ZSH_DOTENV_ALLOWED_LIST
+
+The default behavior of the plugin is to always ask whether to source a dotenv file. There's
+a **Y**es, **N**o, and **A**lways option. If you choose Always, the directory of the .env file
+will be added to an allowed list. If a directory is found in this list, the plugin won't ask
+for confirmation and will instead source the .env file directly.
+
+This allowed list is saved by default in `$ZSH_CACHE_DIR/dotenv-allowed.list`. If you want
+to change that location, change the `$ZSH_DOTENV_ALLOWED_LIST` variable, like so:
+
+```zsh
+# in ~/.zshrc, before Oh My Zsh is sourced:
+ZSH_DOTENV_ALLOWED_LIST=/path/to/dotenv/allowed/list
+```
+
+This file is just a list of directories allowed, separated by a newline character. If you want
+to disallow a directory, just edit this file and remove the line for the directory you want to
+disallow.
## Version Control
@@ -58,5 +81,6 @@ Set `ZSH_DOTENV_PROMPT=false` in your zshrc file if you don't want the confirmat
This plugin only sources the `.env` file. Nothing less, nothing more. It doesn't do any checks. It's designed to be the fastest and simplest option. You're responsible for the `.env` file content. You can put some code (or weird symbols) there, but do it on your own risk. `dotenv` is the basic tool, yet it does the job.
If you need more advanced and feature-rich ENV management, check out these awesome projects:
+
* [direnv](https://github.com/direnv/direnv)
* [zsh-autoenv](https://github.com/Tarrasch/zsh-autoenv)
diff --git a/plugins/dotenv/dotenv.plugin.zsh b/plugins/dotenv/dotenv.plugin.zsh
index 54036bee3..ac3210d7f 100644
--- a/plugins/dotenv/dotenv.plugin.zsh
+++ b/plugins/dotenv/dotenv.plugin.zsh
@@ -1,35 +1,46 @@
+## Settings
+
+# Filename of the dotenv file to look for
+: ${ZSH_DOTENV_FILE:=.env}
+
+# Path to the file containing allowed paths
+: ${ZSH_DOTENV_ALLOWED_LIST:="${ZSH_CACHE_DIR:-$ZSH/cache}/dotenv-allowed.list"}
+
+
+## Functions
+
source_env() {
if [[ -f $ZSH_DOTENV_FILE ]]; then
- if [ "$ZSH_DOTENV_PROMPT" != "false" ]; then
- # confirm before sourcing file
- local confirmation
- # print same-line prompt and output newline character if necessary
- echo -n "dotenv: source '$ZSH_DOTENV_FILE' file in the directory? (Y/n) "
- read -k 1 confirmation; [[ "$confirmation" != $'\n' ]] && echo
- # only bail out if confirmation character is n
- if [[ "$confirmation" = [nN] ]]; then
- return
+ if [[ "$ZSH_DOTENV_PROMPT" != false ]]; then
+ local confirmation dirpath="${PWD:A}"
+
+ # make sure there is an allowed file
+ touch "$ZSH_DOTENV_ALLOWED_LIST"
+
+ # check if current directory's .env file is allowed or ask for confirmation
+ if ! grep -q "$dirpath" "$ZSH_DOTENV_ALLOWED_LIST" &>/dev/null; then
+ # print same-line prompt and output newline character if necessary
+ echo -n "dotenv: found '$ZSH_DOTENV_FILE' file. Source it? ([Y]es/[n]o/[a]lways) "
+ read -k 1 confirmation; [[ "$confirmation" != $'\n' ]] && echo
+
+ # check input
+ case "$confirmation" in
+ [nN]) return ;;
+ [aA]) echo "$dirpath" >> "$ZSH_DOTENV_ALLOWED_LIST" ;;
+ *) ;; # interpret anything else as a yes
+ esac
fi
fi
# test .env syntax
zsh -fn $ZSH_DOTENV_FILE || echo "dotenv: error when sourcing '$ZSH_DOTENV_FILE' file" >&2
- if [[ -o a ]]; then
- source $ZSH_DOTENV_FILE
- else
- set -a
- source $ZSH_DOTENV_FILE
- set +a
- fi
+ setopt localoptions allexport
+ source $ZSH_DOTENV_FILE
fi
}
autoload -U add-zsh-hook
add-zsh-hook chpwd source_env
-if [[ -z $ZSH_DOTENV_FILE ]]; then
- ZSH_DOTENV_FILE=.env
-fi
-
source_env